OGRE: Ogre::CgProgram Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::CgProgram Class Reference
Plugins » CgProgramManager

Specialisation of HighLevelGpuProgram to provide support for nVidia's CG language. More...

`#include <OgreCgProgram.h>`

Inheritance diagram for Ogre::CgProgram:
[legend]

## Classes
class | CmdArgs
| Command object for setting compilation arguments. More...
class | CmdProfiles
| Command object for setting profiles. More...

## Public Member Functions
| CgProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader, CGcontext context)
| ~CgProgram ()
GpuProgram * | _getBindingDelegate () override
| Returns the GpuProgram which should be bound to the pipeline.
GpuProgramParametersSharedPtr | createParameters () override
| Creates a new parameters object compatible with this program definition.
const GpuProgramParametersPtr & | getDefaultParameters (void) override
| Get a reference to the default parameters which are to be used for all uses of this program.
const String & | getEntryPoint (void) const
| Gets the entry point defined for this program.
const String & | getLanguage (void) const override
| Overridden from GpuProgram.
bool | getPassFogStates (void) const override
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).
bool | getPassSurfaceAndLightStates (void) const override
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).
bool | getPassTransformStates (void) const override
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
const StringVector & | getProfiles (void) const
| Gets the Cg profiles which can be supported by the program.
size_t | getSize (void) const
bool | hasCompileError (void) const override
| Did this program encounter a compile error when loading?
bool | hasDefaultParameters (void) const override
| Returns true if default parameters have been set up.
bool | isMorphAnimationIncluded (void) const override
| Returns whether a vertex program can do morph animation.
bool | isPoseAnimationIncluded (void) const override
| Returns whether a vertex program can do pose animation.
bool | isSkeletalAnimationIncluded (void) const override
| Returns whether a vertex program can do skeletal animation.
bool | isSupported (void) const override
| Overridden from GpuProgram.
bool | isVertexTextureFetchRequired (void) const override
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
void | resetCompileError (void) override
| Reset a compile error if it occurred, allowing the load to be retried.
void | setEntryPoint (const String &entryPoint)
| Sets the entry point for this program ie the first method called.
void | setProfiles (const StringVector &profiles)
| Sets the Cg profiles which can be supported by the program.
void | touch (void) override
| 'Touches' the resource to indicate it has been used.
Public Member Functions inherited from Ogre::HighLevelGpuProgram
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram ()
GpuProgram * | _getBindingDelegate (void) override
| Returns the GpuProgram which should be bound to the pipeline.
size_t | calculateSize (void) const override
| Calculate the size of a resource; this will only be called after 'load'.
GpuProgramParametersSharedPtr | createParameters (void) override
| Creates a new parameters object compatible with this program definition.
const GpuNamedConstants & | getConstantDefinitions () override
| Get the full list of GpuConstantDefinition instances.
const String & | getEntryPoint (void) const
| Gets the entry point defined for this program.
const String & | getPreprocessorDefines (void) const
| Gets the preprocessor defines used to compile the program.
void | setEntryPoint (const String &entryPoint)
| Sets the entry point for this program i.e, the first method called.
void | setPreprocessorDefines (const String &defines)
| Sets the preprocessor defines used to compile the program.
Public Member Functions inherited from Ogre::GpuProgram
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
virtual | ~GpuProgram ()
uint32 | _getHash (uint32 seed=0) const
| internal method to get the microcode cache id
const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual const String & | getSource (void) const
| Gets the assembler source for this program.
const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program.
const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g.
GpuProgramType | getType (void) const
| Get the program type.
void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
void | setInstancingIncluded (bool included)
| Sets whether a vertex program can do instancing.
bool | isInstancingIncluded (void) const
| Returns whether a vertex program can do instancing.
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program can do skeletal animation.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program can do morph animation.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program can do pose animation.
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
Static Public Member Functions inherited from Ogre::HighLevelGpuProgram
static String | _resolveIncludes (const String &source, Resource *resourceBeingLoaded, const String &fileName, bool supportsFilename=false)
| Scan the source for #include and replace with contents from OGRE resources.
Static Public Member Functions inherited from Ogre::GpuProgram
static const String | getProgramTypeName (GpuProgramType programType)
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

Specialisation of HighLevelGpuProgram to provide support for nVidia's CG language.

Cg can be used to compile common, high-level, C-like code down to assembler language for both GL and Direct3D, for multiple graphics cards. You must supply a list of profiles which your program must support using setProfiles() before the program is loaded in order for this to work. The program will then negotiate with the renderer to compile the appropriate program for the API and graphics card capabilities.

## Constructor & Destructor Documentation

## ◆ CgProgram()

Ogre::CgProgram::CgProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | CGcontext | context )

## ◆ ~CgProgram()

Ogre::CgProgram::~CgProgram | ( |  | ) |

## Member Function Documentation

## ◆ setEntryPoint()

void Ogre::CgProgram::setEntryPoint | ( | const String & | entryPoint | ) |
| inline

Sets the entry point for this program ie the first method called.

## ◆ getEntryPoint()

const String & Ogre::CgProgram::getEntryPoint | ( | void |  | ) | const
| inline

Gets the entry point defined for this program.

## ◆ setProfiles()

void Ogre::CgProgram::setProfiles | ( | const StringVector & | profiles | ) |

Sets the Cg profiles which can be supported by the program.

## ◆ getProfiles()

const StringVector & Ogre::CgProgram::getProfiles | ( | void |  | ) | const
| inline

Gets the Cg profiles which can be supported by the program.

## ◆ isSupported()

bool Ogre::CgProgram::isSupported | ( | void |  | ) | const
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ getLanguage()

const String & Ogre::CgProgram::getLanguage | ( | void |  | ) | const
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ createParameters()

GpuProgramParametersSharedPtr Ogre::CgProgram::createParameters | ( |  | ) |
| overridevirtual

Creates a new parameters object compatible with this program definition.

It is recommended that you use this method of creating parameters objects rather than going direct to GpuProgramManager, because this method will populate any implementation-specific extras (like named parameters) where they are appropriate.

Reimplemented from Ogre::GpuProgram.

## ◆ _getBindingDelegate()

GpuProgram * Ogre::CgProgram::_getBindingDelegate | ( | void |  | ) |
| overridevirtual

Returns the GpuProgram which should be bound to the pipeline.

This method is simply to allow some subclasses of GpuProgram to delegate the program which is bound to the pipeline to a delegate, if required.

Reimplemented from Ogre::GpuProgram.

## ◆ isSkeletalAnimationIncluded()

bool Ogre::CgProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const
| overridevirtual

Returns whether a vertex program can do skeletal animation.

If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isMorphAnimationIncluded()

bool Ogre::CgProgram::isMorphAnimationIncluded | ( | void |  | ) | const
| overridevirtual

Returns whether a vertex program can do morph animation.

If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isPoseAnimationIncluded()

bool Ogre::CgProgram::isPoseAnimationIncluded | ( | void |  | ) | const
| overridevirtual

Returns whether a vertex program can do pose animation.

If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isVertexTextureFetchRequired()

bool Ogre::CgProgram::isVertexTextureFetchRequired | ( | void |  | ) | const
| overridevirtual

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented from Ogre::GpuProgram.

## ◆ getDefaultParameters()

const GpuProgramParametersPtr & Ogre::CgProgram::getDefaultParameters | ( | void |  | ) |
| overridevirtual

Get a reference to the default parameters which are to be used for all uses of this program.

A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented from Ogre::GpuProgram.

## ◆ hasDefaultParameters()

bool Ogre::CgProgram::hasDefaultParameters | ( | void |  | ) | const
| overridevirtual

Returns true if default parameters have been set up.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassSurfaceAndLightStates()

bool Ogre::CgProgram::getPassSurfaceAndLightStates | ( | void |  | ) | const
| overridevirtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).

Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ getPassFogStates()

bool Ogre::CgProgram::getPassFogStates | ( | void |  | ) | const
| overridevirtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).

On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassTransformStates()

bool Ogre::CgProgram::getPassTransformStates | ( | void |  | ) | const
| overridevirtual

Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.

Most vertex programs do not need fixed-function transform information, however GLSL shaders can refer to this state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ hasCompileError()

bool Ogre::CgProgram::hasCompileError | ( | void |  | ) | const
| overridevirtual

Did this program encounter a compile error when loading?

Reimplemented from Ogre::GpuProgram.

## ◆ resetCompileError()

void Ogre::CgProgram::resetCompileError | ( | void |  | ) |
| overridevirtual

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented from Ogre::GpuProgram.

## ◆ getSize()

size_t Ogre::CgProgram::getSize | ( | void |  | ) | const

## ◆ touch()

void Ogre::CgProgram::touch | ( | void |  | ) |
| overridevirtual

'Touches' the resource to indicate it has been used.

Reimplemented from Ogre::Resource.

The documentation for this class was generated from the following file:

- OgreCgProgram.h